

/* Phile Code.  This file contains the code designed for the menu
   ie: the Phile Menu.  Used to spawn open window for opening files  
					    Written By Assassin Softwarez
						Justin Moon
						Stuart Wilcox
						William Shales
						Michael Norris                   */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1.13X */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <process.h>
#include <sys/kernel.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <mem.h>
#include <photon/PhRender.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "globals.h"
#include "abimport.h"
#include "proto.h"


#include <sys/kernel.h>
#include <sys/types.h>
#include <signal.h>
#include <ctype.h>
#include <sys/wait.h>

#define PX_IMAGE_MODULES
#define PX_BMP_SUPPORT
#define PX_JPG_SUPPORT

#include <photon/PxImage.h>

#define ISFILE 1
#define ISPAGE 2
#define ISCLOSE 3

/*RESIZELABEL function
  Used to... resize the label
*/
void 
ResizeLabel(void);

void
SetPageNum(int CurrentPage);

int 
First_Run_Call(void);

/* PHILE_OPEN_CB_ACTIVATE function
   Uses standard photon "Open" window to open new files
*/

struct Proto SendBuff;//buffer to send messages to pdftotextP with
struct PagePass * PdfText;//structure to get page in
static int Num_Of_Files=0;
char files[5][80];
int lastpage;
char * gounta; // This, Is Food And Pointer To Mapped Shared Memory
char cwd [25];
int child; //pid of pdftotextP
int cur_page; //global current page
int FileOpen;
int m_size;

int
CheckFileExt(char * FPath,int PLen)
{
	int i,strcount;
	char ext[3];
	strcount=PLen-3;	
	for (i=strcount;i<PLen;i++)
	{
		ext[i-strcount]=toupper(FPath[i]);
	}
	
	if (strcmp("PDF",&ext)==0)
		return (1);
	else
		return (0);
}		

int
Phile_mnu_LastFile_CB_Activate (PtWidget_t * widget, void * client_data ,PtCallbackInfo_t * call_data)
{
	PtArg_t args[5];
	char * text;
	char temp[20];
	char page_num[5];
	char cwd [60];
	char WorkingDir[160];
	int counter;
	int counter2;
	FILE* Input;

	PtSetArg (&args[0],Pt_ARG_TEXT_STRING,&text,0);
	PtGetResources(widget,1,args);

	fd=shm_open("Endor",O_RDWR | O_CREAT,0777);
	if(ltrunc(fd,(1000*PAGESIZE),SEEK_SET)==-1) 
		fprintf(stderr,"error %s\n",strerror(errno));
	gounta=mmap(0,(1000*PAGESIZE),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);

	if (FileOpen==1)
	{
		kill (child,SIGKILL);
		wait(&child);
		FileOpen=0;
		SetPageNum(0);

		strcpy(temp,"Of 0");
		PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&temp,0);
		PtSetResources(ABW_Ppdf_lbl_MaxPg, 1, args);
	}
	if(CheckFileExt(text,strlen(text)))
	// if file extension is PDF
	{
		strcpy(&WorkingDir,&Pathd);
		strcat(&WorkingDir,"/pdftotextP");
		child=spawnl(P_NOWAIT,&WorkingDir,&WorkingDir,"Continue",NULL,0);	
		//child=spawnl(P_NOWAIT,"pdftotextP","pdftotextP","Continue",NULL,0);		
		SendBuff.m_Type=ISFILE;
		strcpy (SendBuff.m_FileName,text);

	
		PtSetArg(&args[0],Pt_ARG_WINDOW_TITLE,text,0);
		PtSetResources(ABW_Ppdf, 1, args);

		Send(child,&SendBuff,&m_size,sizeof(struct Proto),sizeof(m_size));
		Send(child,&SendBuff,&lastpage,sizeof(struct Proto),sizeof(lastpage));
		//print number of pages on GUI
		itoa(lastpage,&page_num,10);
		strcpy(temp,"Of ");
		strcat(temp,page_num);
	
		PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&temp,0);
		PtSetResources(ABW_Ppdf_lbl_MaxPg, 1, args);
			
		PdfText=(struct PagePass *) malloc(sizeof(struct PagePass) + (m_size * sizeof (struct m_Page)));

		memcpy(PdfText,gounta,(sizeof(struct PagePass) + (m_size * sizeof (struct m_Page))));

		cur_page=1;	
		FileOpen=1;
		First_Run_Call();
		SetPageNum(1);
	}
	 
    for (counter=0;counter<Num_Of_Files;counter++)
	{
		if (strcmp(text,&files[counter])==0)
          break;
	}

	if (counter!=Num_Of_Files)
    {
		for (counter2=counter;counter2>0;counter2--)
 		{
			strcpy(&files[counter2],&files[counter2-1]);
		}
		strcpy(&files[0],text);

		strcpy(&WorkingDir,&Pathd);
		strcat(&WorkingDir,"/lastfile.txt");
		Input=fopen(WorkingDir,"w");
		itoa(Num_Of_Files,temp,10);
    
		fputs(&temp,Input);
		fputs("\n",Input);

		for (counter=0;counter<Num_Of_Files;counter++)
		{           	   
			fputs(&files[counter],Input);
		    fputs("\n",Input);
		}

		fclose(Input);

	}

	return 1;	
}

int
Phile_Open_CB_Activate( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
    /*Local Variables*/
	PtFileSelectionInfo_t Info;  
	PtArg_t args[5];
	char RxBuff [20];

	PhImage_t * Image;
    PxMethods_t methods;
	FILE* Input;
	char page_num[5];
	char temp[25];
	char WorkingDir [160];
	int counter,counter2;

	fd=shm_open("Endor",O_RDWR | O_CREAT,0777);
	if(ltrunc(fd,(1000*PAGESIZE),SEEK_SET)==-1) 
		fprintf(stderr,"error %s\n",strerror(errno));
	gounta=mmap(0,(1000*PAGESIZE),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);

      /*Set methods structure to 0*/
      memset (&methods, 0, sizeof (PxMethods_t));
     
	  memset(&Info,0,sizeof(Info));

	//Open photon open window
	PtFileSelection(ABW_Ppdf,NULL,"OpenFile","/","*","&Open",NULL,
					"nsd",&Info,0);

	//Get file to be opened
	if (Info.ret==Pt_FSDIALOG_BTN1)
	{
		strcpy(cur_file,Info.path);
	}
	else
		strcpy(cur_file,"");

	if (FileOpen==1)
	{
		kill (child,SIGKILL);
		wait(&child);
		FileOpen=0;
		SetPageNum(0);

		strcpy(temp,"Of 0");
		PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&temp,0);
		PtSetResources(ABW_Ppdf_lbl_MaxPg, 1, args);
	}
	if(CheckFileExt(&cur_file,strlen(cur_file)))
	// if file extension is PDF
	{
		strcpy(&WorkingDir,&Pathd);
		strcat(&WorkingDir,"/pdftotextP");
		child=spawnl(P_NOWAIT,&WorkingDir,&WorkingDir,"Continue",NULL,0);
		//child=spawnl(P_NOWAIT,"pdftotextP","pdftotextP","Continue",NULL,0);			
		SendBuff.m_Type=ISFILE;
		strcpy (SendBuff.m_FileName,cur_file);

		PtSetArg(&args[0],Pt_ARG_WINDOW_TITLE,cur_file,0);
		PtSetResources(ABW_Ppdf, 1, args);

		Send(child,&SendBuff,&m_size,sizeof(struct Proto),sizeof(m_size));
		Send(child,&SendBuff,&lastpage,sizeof(struct Proto),sizeof(lastpage));
		//print number of pages on GUI
		itoa(lastpage,&page_num,10);
		strcpy(temp,"Of ");
		strcat(temp,page_num);
	
		PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&temp,0);
		PtSetResources(ABW_Ppdf_lbl_MaxPg, 1, args);	
		PdfText=(struct PagePass *) malloc(sizeof(struct PagePass) + (m_size * sizeof (struct m_Page)));

		memcpy(PdfText,gounta,(sizeof(struct PagePass) + (m_size * sizeof (struct m_Page))));
		cur_page=1;	
		FileOpen=1;
		strcpy(&WorkingDir,&Pathd);
		strcat(&WorkingDir,"/lastfile.txt");
		if (Num_Of_Files==0)
		  {
			if (strcmp(cur_file,""))
			{
				

				strcpy(files[Num_Of_Files],cur_file);
				Num_Of_Files++;
				Input=fopen(WorkingDir,"w");
				itoa(Num_Of_Files,temp,10);
				fputs(&temp,Input);
				fputs("\n",Input);
				fputs(&files[Num_Of_Files-1],Input);
				fputs("\n",Input);
				fclose(Input);
			}
		  }
		else
		  { 	
			if (strcmp(cur_file,""))
			{
				
    		for (counter=0;counter<Num_Of_Files;counter++)
			{
				if (strcmp(&cur_file,&files[counter])==0)
          		  break;
			}

			if (counter!=Num_Of_Files)
    		{
				for (counter2=counter;counter2>0;counter2--)
 				{
					strcpy(&files[counter2],&files[counter2-1]);
				}
				strcpy(&files[0],&cur_file);
			}
			else
			{

				for (counter=Num_Of_Files;counter>0;counter--)
				   if (counter!=5)
					 strcpy(files[counter],files[counter-1]);
		
				strcpy(files[0],&cur_file);
				if (Num_Of_Files!=5)
					Num_Of_Files++;
			}
			
				Input=fopen(WorkingDir,"w");
				itoa(Num_Of_Files,temp,10);
    
				fputs(&temp,Input);
				fputs("\n",Input);

				for (counter=0;counter<Num_Of_Files;counter++)
					{           	   
						fputs(&files[counter],Input);
						fputs("\n",Input);
					}

				fclose(Input);
			}		
		  }
	
		First_Run_Call();
		SetPageNum(1);
	}
	else
		First_Run_Call();
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

/*  PHILE_MF_LASTOPENEDCB
    Shows the last opened file in the Phile menu
*/
int
Phile_mf_LastOpenedCB( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	FILE* Input;
	int counter;
	char value[80];
	int temp;
	char WorkingDir [160];
	int Phile_mnu_LastFile_CB_Activate (PtWidget_t *,void *,PtCallbackInfo_t *);

	PtCallback_t callbacks[] = {{Phile_mnu_LastFile_CB_Activate,NULL}};

	strcpy(&WorkingDir,&Pathd);
	strcat(&WorkingDir,"/lastfile.txt");

	Input=fopen(WorkingDir,"r");
    if (Input!=NULL)
	{
			fgets(value,80,Input);
			Num_Of_Files=atoi(value);
			for (counter=0;counter<Num_Of_Files;counter++)
			{
				fgets(files[counter],80,Input);
				temp=strlen(files[counter]);
				files[counter][temp-1]='\x0';
			}
			fclose(Input);

		    for (counter=0;counter<Num_Of_Files;counter++)
		    {
				PtWidget_t *FileName;  //New widget for creation
				PtArg_t arg[1];
	
				//Set the string to be displayed
				PtSetArg(&arg[0],Pt_ARG_TEXT_STRING,&files[counter],0);
				FileName=PtCreateWidget(PtMenuButton,NULL,1,arg);
				PtAddCallbacks(FileName,Pt_CB_ACTIVATE,callbacks,1);

				/* eliminate 'unreferenced' warnings */
				widget = widget, apinfo = apinfo, cbinfo = cbinfo;
		    }
	}
	else
	{
				Input=fopen(WorkingDir,"w");
				fputs("0\n",Input);
				fclose(Input);
	}	
	return( Pt_CONTINUE );

	}

int
Phile_EXIT_CB_Activate( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	
	kill (child,SIGKILL);
	shm_unlink("Endor");
	shm_unlink("ShMem");
	
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}


int
Phile_mnu_Close_Activate_CB( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	char * temp="Of 0";
	PtArg_t args[5];

	if (FileOpen==1)
	{
		kill (child,SIGKILL);
		wait(&child);
		FileOpen=0;
		SetPageNum(0);

		PtSetArg(&args[0],Pt_ARG_TEXT_STRING,temp,0);
		PtSetResources(ABW_Ppdf_lbl_MaxPg, 1, args);

		PtSetArg(&args[0],Pt_ARG_WINDOW_TITLE,"Ppdf",0);
		PtSetResources(ABW_Ppdf, 1, args);

		First_Run_Call();
	}
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}


int
Phile_btn_About_CB_us( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

	{
	char WorkingDir [160];
	PtArg_t args[5];
	PhImage_t Image2;
	PhImage_t * Image;
	PxMethods_t methods;
	PhPoint_t trans = { 0,0 }, textloc,imagesize;
	PhDim_t dim = { 600,800 };
	PmMemoryContext_t *img;
	short bytes = 3;

	strcpy(&WorkingDir,&Pathd);
	strcat(&WorkingDir,"/us.jpg");

      /*Set all variables to 0 in methods structure*/

	memset (&Image2, 0, sizeof(PhImage_t));

	Image2.type = Pg_IMAGE_DIRECT_888;
	Image2.size = dim;
	Image2.image = PgShmemCreate(dim.w * dim.h * bytes,"ShMem");

	img=PmMemCreateMC(&Image2, &dim, &trans);
	PmMemStart(img);
	
	memset (&methods,0,sizeof(PxMethods_t));

	PgSetFillColor(Pg_WHITE);
	
	PgSetStrokeColor(Pg_BLACK);

	PgSetTextColor(Pg_BLACK);
	PgDrawIRect (0,0,dim.w,dim.h,Pg_DRAW_FILL_STROKE);

    textloc.x=0;
    textloc.y=200;
	methods.flags=PX_LOAD|PX_DIRECT_COLOR|PX_USECOLORS;

 	Image=PxLoadImage(&WorkingDir,&methods);
	if (Image!= NULL)
	PgDrawImage(Image->image, Image->type, &textloc, &Image->size, Image->bpl,0);

	strcpy(&WorkingDir,&Pathd);
	strcat(&WorkingDir,"/logo2.jpg");

	textloc.x=0;
    textloc.y=0;
	methods.flags=PX_LOAD|PX_DIRECT_COLOR|PX_USECOLORS;

 	Image=PxLoadImage(&WorkingDir,&methods);
	if (Image!= NULL)
	PgDrawImage(Image->image, Image->type, &textloc, &Image->size, Image->bpl,0);

	textloc.x=200;
    textloc.y=100;
	PgSetFont ("helv30b");
	PgDrawText("ASSASSIN SOFTWAREZ",18,&textloc,0);

    PmMemFlush(img,&Image2);
		
	PmMemStop(img);
	PmMemReleaseMC (img);
    //Assign image to label
	PtSetArg(&args[0],Pt_ARG_LABEL_DATA,&Image2,sizeof(Image2));
	PtSetResources(ABW_Ppdf_lbl_PDFText, 1, args);

	ResizeLabel();	//Resizes Label to size of scroll area


	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	return( Pt_CONTINUE );

	}

